Loading...
Searching...
No Matches
better_enums::map< Enum, T, Compare > Struct Template Reference

`#include <enum.h>`

## Public Types

typedef T(* | function) (Enum)

## Public Member Functions

BETTER_ENUMS_CONSTEXPR_ | map (function f)
BETTER_ENUMS_CONSTEXPR_ T | from_enum (Enum value) const
BETTER_ENUMS_CONSTEXPR_ T | operator[] (Enum value) const
BETTER_ENUMS_CONSTEXPR_ Enum | to_enum (T value) const
BETTER_ENUMS_CONSTEXPR_ optional< Enum > | to_enum_nothrow (T value, size_t index=0) const

## Detailed Description

template<typename Enum, typename T, typename Compare = map_compare<T>>
struct better_enums::map< Enum, T, Compare >

Definition at line 1277 of file enum.h.

## Member Typedef Documentation

## function

template<typename Enum, typename T, typename Compare = map_compare<T>>

typedef T(* better_enums::map< Enum, T, Compare >::function) (Enum)

Definition at line 1278 of file enum.h.

## Constructor & Destructor Documentation

## map()

template<typename Enum, typename T, typename Compare = map_compare<T>>

BETTER_ENUMS_CONSTEXPR_ better_enums::map< Enum, T, Compare >::map | ( | function | f | ) |

inline explicit

Definition at line 1280 of file enum.h.

References BETTER_ENUMS_CONSTEXPR_.

## Member Function Documentation

## from_enum()

template<typename Enum, typename T, typename Compare = map_compare<T>>

BETTER_ENUMS_CONSTEXPR_ T better_enums::map< Enum, T, Compare >::from_enum | ( | Enum | value | ) | const

inline

Definition at line 1282 of file enum.h.

References BETTER_ENUMS_CONSTEXPR_.

## operator[]()

template<typename Enum, typename T, typename Compare = map_compare<T>>

BETTER_ENUMS_CONSTEXPR_ T better_enums::map< Enum, T, Compare >::operator[] | ( | Enum | value | ) | const

inline

Definition at line 1283 of file enum.h.

References BETTER_ENUMS_CONSTEXPR_.

## to_enum()

template<typename Enum, typename T, typename Compare = map_compare<T>>

BETTER_ENUMS_CONSTEXPR_ Enum better_enums::map< Enum, T, Compare >::to_enum | ( | T | value | ) | const

inline

Definition at line 1286 of file enum.h.

References BETTER_ENUMS_CONSTEXPR_, and to_enum_nothrow().

## to_enum_nothrow()

template<typename Enum, typename T, typename Compare = map_compare<T>>

BETTER_ENUMS_CONSTEXPR_ optional< Enum > better_enums::map< Enum, T, Compare >::to_enum_nothrow | ( | T | value,
|  | size_t | index = 0 ) const

inline

Definition at line 1293 of file enum.h.

References to_enum_nothrow().

Referenced by to_enum(), and to_enum_nothrow().

The documentation for this struct was generated from the following file:

- enum.h